<?xml version='1.0'?>

<xsl:stylesheet xmlns:xsl      = 'http://www.w3.org/1999/XSL/Transform'
                xmlns:xsd      = 'http://www.w3.org/2001/XMLSchema'
                xmlns:java     = 'http://xml.apache.org/xslt/java'
                xmlns:wf       = 'com.ibm.workflow.util.fdl.make.WSDL'
                xmlns:redirect = 'org.apache.xalan.xslt.extensions.Redirect'
                extension-element-prefixes='redirect'
                version='1.0'>

<xsl:param name='generator'/>
<xsl:param name='package'/>
<xsl:param name='basedir'/>
<xsl:param name='output'/>
<xsl:param name='sns'/>

<xsl:output method='text'/>

<xsl:template match='text()'/>

<xsl:template match='/'>
 <xsl:apply-templates/>
</xsl:template>

<xsl:template match='xsd:schema'>
 <xsl:for-each select='./xsd:complexType[starts-with(@name, $sns)]'>
  <xsl:variable name='typeName' select='wf:globalName(@name)'/>
  <xsl:variable name='fileName' select='wf:getFileName($typeName, $basedir, $package, ".java")'/>
  <redirect:write select='$fileName'>
  <xsl:text>// MQSeries Workflow SOAP Wrapper class for '</xsl:text>
  <xsl:value-of select='$typeName'/>
  <xsl:text>' STRUCTUREs
// This file ("</xsl:text>
  <xsl:variable name='javaFile' select='java:java.io.File.new($fileName)'/>
  <xsl:variable name='absoluteFileName' select='java:getAbsolutePath($javaFile)'/>
  <xsl:value-of select='$absoluteFileName'/>
  <xsl:text>")
// was generated by </xsl:text>
  <xsl:value-of select='$generator'/>
  <xsl:text> on </xsl:text>
  <xsl:value-of select='java:java.util.Date.new()'/>
  <xsl:text>
// from WSDL file "</xsl:text>
  <xsl:value-of select='$output'/>
  <xsl:text>"</xsl:text>
  <xsl:if test='$package!=""'>
   <xsl:text>

package </xsl:text>
   <xsl:value-of select='$package'/>
   <xsl:text>;</xsl:text>
  </xsl:if>
  <xsl:text>

public class </xsl:text>
  <xsl:value-of select='$typeName'/>
  <xsl:text>
{</xsl:text>
  <xsl:for-each select='.//xsd:element'>
   <xsl:variable name='javaTypeName' select='wf:getJavaType($package, @type, @maxOccurs)'/>
   <xsl:variable name='fieldName' select='concat(@name, "_Elem")'/>
   <xsl:text>
  public </xsl:text>
   <xsl:value-of select='$javaTypeName'/>
   <xsl:text> </xsl:text>
   <xsl:value-of select='$fieldName'/>
   <xsl:text>;</xsl:text>
  </xsl:for-each>
  <xsl:text>

  public </xsl:text>
  <xsl:value-of select='$typeName'/>
  <xsl:text>() { }</xsl:text>
  <xsl:text>

  public </xsl:text>
  <xsl:value-of select='$typeName'/>
  <xsl:text>(</xsl:text>
  <xsl:for-each select='.//xsd:element'>
   <xsl:variable name='javaTypeName' select='wf:getJavaType($package, @type, @maxOccurs)'/>
   <xsl:variable name='fieldName' select='concat(@name, "_Elem")'/>
   <xsl:value-of select='$javaTypeName'/>
   <xsl:text> </xsl:text>
   <xsl:value-of select='$fieldName'/>
   <xsl:if test='not(position()=last())'><xsl:text>, </xsl:text></xsl:if>
  </xsl:for-each>
   <xsl:text>)
  {</xsl:text>
  <xsl:for-each select='.//xsd:element'>
   <xsl:variable name='fieldName' select='concat(@name, "_Elem")'/>
   <xsl:text>
    this.</xsl:text>
   <xsl:value-of select='$fieldName'/>
   <xsl:text> = </xsl:text>
   <xsl:value-of select='$fieldName'/>
   <xsl:text>;</xsl:text>
  </xsl:for-each>
  <xsl:text>
  }
}
  </xsl:text>
  </redirect:write>
 </xsl:for-each>
</xsl:template>

</xsl:stylesheet>
