package com.wspmtk.www.sample.schema;

import java.io.*;
import org.w3c.dom.*;
import org.apache.soap.*;
import org.apache.soap.encoding.soapenc.*;
import org.apache.soap.rpc.*;
import org.apache.soap.util.*;
import org.apache.soap.util.xml.*;

public class CreditInfoSerializer implements Serializer, Deserializer
{
  //private XMLParserLiaison xpl = new XercesParserLiaison();

  public void marshall(String inScopeEncStyle, Class javaType,
  Object src, Object context, Writer sink,
  NSStack nsStack, XMLJavaMappingRegistry xjmr,
  SOAPContext ctx)
  throws IllegalArgumentException, IOException
  {
    nsStack.pushScope();

    SoapEncUtils.generateStructureHeader(inScopeEncStyle, javaType, context,
      sink, nsStack, xjmr);

    sink.write(StringUtils.lineSeparator);

    CreditInfo src2 =
      (CreditInfo)src;
    Parameter param;

    param = new Parameter("CreditRequestor",
      PersonInfo.class, src2.CreditRequestor_Elem,
      null);
    xjmr.marshall(inScopeEncStyle, Parameter.class, param, null,
    sink, nsStack, ctx);
    sink.write(StringUtils.lineSeparator);

    param = new Parameter("Address", java.lang.String.class, src2.Address_Elem,
      null);
    xjmr.marshall(inScopeEncStyle, Parameter.class, param, null,
    sink, nsStack, ctx);
    sink.write(StringUtils.lineSeparator);

    param = new Parameter("RiskFactor", java.lang.String.class,
      src2.RiskFactor_Elem, null);
    xjmr.marshall(inScopeEncStyle, Parameter.class, param, null,
    sink, nsStack, ctx);
    sink.write(StringUtils.lineSeparator);

    param = new Parameter("AddApproval", java.lang.String.class,
      src2.AddApproval_Elem, null);
    xjmr.marshall(inScopeEncStyle, Parameter.class, param, null,
    sink, nsStack, ctx);
    sink.write(StringUtils.lineSeparator);

    param = new Parameter("CreditAmount", long.class, new Long
      (src2.CreditAmount_Elem), null);
    xjmr.marshall(inScopeEncStyle, Parameter.class, param, null,
    sink, nsStack, ctx);
    sink.write(StringUtils.lineSeparator);


    sink.write("</" + context + '>');

    nsStack.popScope();
  }

  public Bean unmarshall(String inScopeEncStyle, QName elementType,
  Node src, XMLJavaMappingRegistry xjmr,
  SOAPContext ctx)
  throws IllegalArgumentException
  {
    Element root = (Element)src;
    Element tempEl = DOMUtils.getFirstChildElement(root);
    CreditInfo target;

    try
    {
      target =
        (CreditInfo)CreditInfo.class.newInstance
        ();
    }
    catch (Exception e)
    {
      throw new IllegalArgumentException("Problem instantiating bean: "
        + e.getMessage());
    }

    while (tempEl != null)
    {
      Bean paramBean = xjmr.unmarshall(inScopeEncStyle,
      RPCConstants.Q_ELEM_PARAMETER,
      tempEl,
      ctx);
      Parameter param = (Parameter)paramBean.value;
      String tagName = tempEl.getTagName();


      if (tagName.equals("CreditRequestor"))
      {
        target.CreditRequestor_Elem =
          (PersonInfo)param.getValue();
      }

      if (tagName.equals("Address"))
      {
        target.Address_Elem = (java.lang.String)param.getValue();
      }

      if (tagName.equals("RiskFactor"))
      {
        target.RiskFactor_Elem = (java.lang.String)param.getValue();
      }

      if (tagName.equals("AddApproval"))
      {
        target.AddApproval_Elem = (java.lang.String)param.getValue();
      }

      if (tagName.equals("CreditAmount"))
      {
        target.CreditAmount_Elem = ((Long)param.getValue()).longValue();
      }


      tempEl = DOMUtils.getNextSiblingElement(tempEl);
    }

    return new Bean(CreditInfo.class, target);
  }
}
